<template>
  <b-modal
    id="add-user-modal"
    v-model="openModal"
    size="lg"
    title="Création de la ressource principale du jeu de données"
  >
    <p>Sélectionner les actions à effectuer:</p>
    <div>
      <Tree
        id="resource-creation-tree"
        ref="resource-creation-tree"
        :key="treeKey"
        :custom-options="treeCustomOptions"
        :custom-styles="treeCustomStyles"
        :nodes="treeDisplayData"
      />
    </div>
    <template #modal-footer>
      <div class="w-100">
        <b-button
          variant="outline-secondary"
          class="float-left"
          @click="cancel"
        >
          Annuler
        </b-button>
        <b-button
          variant="primary"
          class="float-right"
          @click="confirmSelection"
        >
          Confirmer
        </b-button>
      </div>
    </template>
  </b-modal>
</template>

<script>
import Tree from 'vuejs-tree';

import { renameObjKey } from '@/utils';

export default {
  name: 'ResourceCreationModal',

  components: {
    Tree
  },

  props: {
    open: {
      type: Boolean,
      default: false
    },
    data: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },

  data() {
    return {
      openModal: false,
      treeKey: 1
    }
  },

  computed: {
    treeDisplayData() {
      if (this.data && this.data.actions) {
        let id = 1;
        const treeData = Object.values(this.data.actions);
        for(const item of treeData) {
          for (const key of Object.keys(item)) {
            if (!item.id) {
              item.id = id;
              id += 1;
            }
            if (key === 'description') {
              renameObjKey(item, key, 'text');
            } else if (key === 'subactions') {
              item[key] = Object.values(item[key]);
              renameObjKey(item, key, 'nodes');
              for (const node of item.nodes) {
                for (const nodeKey of Object.keys(node)) {
                  if (!node.id) {
                    node.id = id;
                    id += 1;
                  }
                  if (nodeKey === 'description') {
                    renameObjKey(node, nodeKey, 'text');
                  }
                }
                node.depth = 2;
                node.checkable = true;
                node.state = {
                  checked: true,
                  expanded: true,
                  selected: false
                };
              }
            } else {
              delete item[key];
            }
            item.depth = 1;
            item.checkable = true;
            item.state = {
              checked: true,
              expanded: true,
              selected: false
            };
          }
        }
        return treeData;
      }
      return false;
    },
  treeCustomStyles() {
    return {
      tree: {
        style: {
          height: 'auto',
          overflowY: 'visible',
          display: 'inline-block',
          textAlign: 'left'
        }
      },
      row: {
        style: {
          cursor: 'pointer'
        },
        child: {
          class: '',
          style: {
            height: '25px'
          }
        }
      },
      text: {
        style: {},
        class: 'capitalize',
        active: {
          style: {
            'font-weight': 'bold',
            color: '#2ECC71'
          }
        }
      }
    };
  },
  treeCustomOptions() {
    return {
      treeEvents: {
        expanded: {
          state: false,
          fn: null,
        },
        collapsed: {
          state: false,
          fn: null,
        },
        checked: {
          state: true,
          fn: this.onTreeCheck,
        }
      },
      events: {
        expanded: {
          state: false,
          fn: null,
        },
        checked: {
          state: false,
          fn: null,
        }
      }
    };
  }
},

  watch: {
    open: function(newValue) {
      this.openModal = newValue;
    }
  },

  methods: {
    cancel() {
      this.$emit('hide');
      this.$emit('cancel');
    },

    onTreeCheck(nodeId, state) {
      if (state) {
        for (const root of this.treeDisplayData) {
          if (root.id < nodeId) {
            root.state.checked = true;
          } else if (root.id > nodeId){
            root.state.checked = false;
          }
          if (root.nodes) {
            for (const node of root.nodes) {
              if (node.id < nodeId) {
                node.state.checked = true;
              } else if (node.id > nodeId) {
                root.state.checked = false;
              }
            }
          }
        }
      } else {
        for (const root of this.treeDisplayData) {
          if (root.id > nodeId) {
            root.state.checked = false;
          }
          if (root.nodes) {
            for (const node of root.nodes) {
              if (node.id > nodeId) {
                node.state.checked = false;
              }
            }
          }
        }
      }
      if (this.treeDisplayData.find(el => el.id === nodeId)) {
        this.treeDisplayData.find(el => el.id === nodeId).state.checked = state;
      }
      this.treeKey += 1;
    },

    cleanCheckedTreeData(arr) {
      for (const [index, item] of arr.entries()) {
        for (const key of Object.keys(item)) {
          if (key === 'nodes') {
            cleanCheckedTreeData(item[key]);
          }
        }
      }
    },

    confirmSelection() {
      const checkedActions = JSON.parse(JSON.stringify(this.treeDisplayData));
      checkedActions.forEach((item, index) => {
        if (!item.state.checked) {
          if (item.nodes && item.nodes.length) {
            for (const [nodeIndex, node] of item.nodes.entries()) {
              if (!node.state.checked) {
                item.nodes.splice(nodeIndex, 1);
              }
            }
          } else {
            checkedActions.splice(index, 1);
          }
          if (item.nodes && (item.nodes.every(el => el.state.checked === false) || item.nodes.length === 0)) {
            checkedActions.splice(index, 1);
          }
        }
      });
      this.$emit('actions', checkedActions);
    }
  }
}
</script>

<style lang="less" scoped>

h2 {
  color: @blue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

p {
  margin-left: 1em;
  font-size: 1.1em;
  font-weight: 500;
  text-decoration: underline;
}

.row_data {
  span {
    padding-right: 10px;
  }
}

</style>
